//
//  ViewController.swift
//  DemoRedirect
//
//  Created by Administrator on 14/05/18.
//  Copyright © 2018 Fabricalab. All rights reserved.
//

import UIKit

enum RedirectError: Error {
    case runtimeError(String)
}

class ViewController: UIViewController {

    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }


    @IBAction func buttonTouch(_ sender: Any) {
        let serverName = "http://apple.com"
        RedirectRequester.getRedirectInfo(with: serverName) { result, response in
            print("Redirect \(result): \(response)")
        }
    }
}

fileprivate class RedirectRequester: NSObject, URLSessionTaskDelegate {
    
    private static var sharedInstance = RedirectRequester()
    private static var session: URLSession!
    
    // to prevent redirection
    func urlSession(_ session: URLSession, task: URLSessionTask, willPerformHTTPRedirection response: HTTPURLResponse, newRequest request: URLRequest, completionHandler: @escaping (URLRequest?) -> Void) {
        completionHandler(nil)
    }
    
    class func getRedirectInfo(with url: String, completionHandler: @escaping (Bool, String) -> Void) -> Void {
        if self.session == nil {
            let config = URLSessionConfiguration.default
            self.session = URLSession(configuration: config, delegate: RedirectRequester.sharedInstance, delegateQueue: nil)
        }

        let request = URLRequest(url: URL(string: url)!, cachePolicy: .reloadIgnoringLocalCacheData)
        
        let task = self.session.dataTask(with: request) { data, response, error in
            if let error = error {
                completionHandler(false, error.localizedDescription)
                return
            }
            
            if let httpResponse = response as? HTTPURLResponse {
                if (300...302).contains(httpResponse.statusCode) {
                    completionHandler(true, httpResponse.allHeaderFields["Location"] as! String)
                    return
                }
            }
            
            completionHandler(false, "Redirect request failed")
        }
        task.resume()
    }
}
